--[[-------------------------------------------------------------------------
	SmallerBlizzardRaidFrames
	Copyright (C) 2010  Morsker
	Please contact Morsker through PM on forums.wowace.com.

	Resizes Blizzard raid frames to be smaller squares.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program. If not, see <http://www.gnu.org/licenses/>.
---------------------------------------------------------------------------]]
local addonName = ...
local SBRF = LibStub("AceAddon-3.0"):NewAddon(addonName, "AceEvent-3.0")
_G[addonName] = SBRF
local SavedVars_Name = addonName.."PerCharDB"

--------------
--  Locals  --
--------------

-- GLOBALS: _G
-- GLOBALS: InterfaceOptionsRaidFramePanelRaidFrameHeightSlider
-- GLOBALS: InterfaceOptionsRaidFramePanelRaidFrameWidthSlider
-- GLOBALS: CompactRaidFrameContainer
-- GLOBALS: GetCVar
-- GLOBALS: SetCVar

local GameFontHighlightLarge = GameFontHighlightLarge

local DBVERSION = 1
local db
local frame

--((@)) local counts = {
--((@)) 	fixframe = 0,
--((@)) 	hook2 = 0,
--((@)) 	name = 0,
--((@)) }
--((@)) _G.SBRF = {}
--((@)) SBRF.counts = counts

---------------------
--  Init / Events  --
---------------------

local function HideMe(self)
	self:Hide()
end

function SBRF.FixFrame(frame)
	--((@)) counts.fixframe = counts.fixframe + 1

	local name = frame.name
	name:SetFontObject(GameFontHighlightLarge)
	name:ClearAllPoints()
	name:SetPoint("CENTER")
	
	local buffs = frame.buffFrames
	buffs[1]:SetSize(32, 32)
	buffs[2]:SetSize(32, 32)
	local debuffs = frame.debuffFrames
	debuffs[1]:SetSize(32, 32)
	debuffs[2]:SetSize(32, 32)
	local d_debuffs = frame.dispelDebuffFrames
	d_debuffs [1]:SetSize(32, 32)
	d_debuffs [2]:SetSize(32, 32)

	buffs[1]:ClearAllPoints()
	buffs[1]:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -3, 2)
	debuffs[1]:ClearAllPoints()
	debuffs[1]:SetPoint("TOPLEFT", frame, "TOPLEFT", 3, -2)
	
	if not frame.thirdBuffsHidden then
		buffs[3]:Hide()
		buffs[3]:SetScript("OnShow", HideMe)
		debuffs[3]:Hide()
		debuffs[3]:SetScript("OnShow", HideMe)
		d_debuffs[3]:Hide()
		d_debuffs[3]:SetScript("OnShow", HideMe)
	end
	frame.thirdBuffsHidden = true
end

hooksecurefunc("DefaultCompactUnitFrameSetup", SBRF.FixFrame)
hooksecurefunc("CompactRaidFrameReservation_RegisterReservation", function(_, frame, _)
	--((@)) counts.hook2 = counts.hook2 + 1
	SBRF.FixFrame(frame)
end)

function SBRF.ResizeDebuff(debuffFrame)
	--((@)) counts.resizeDebuff = counts.resizeDebuff + 1
	debuffFrame:SetSize(32, 32)
end

hooksecurefunc("CompactUnitFrame_UtilSetDebuffBossDebuff", SBRF.ResizeDebuff)

function SBRF.TruncateFrameName(frame)
	--((@)) counts.name = counts.name + 1
	local name = frame.name
	local nameText = name:GetText()
	name:SetText(nameText:sub(1,5))
end

hooksecurefunc("CompactUnitFrame_UpdateName", SBRF.TruncateFrameName)

function SBRF:PLAYER_LOGOUT()
	self:UnregisterEvent("PLAYER_LOGOUT")

	SetCVar("raidFramesHeight", self.origHeight)
	SetCVar("raidFramesWidth", self.origWidth)
end

function SBRF:OnInitialize()
	self.OnInitialize = nil

	self.origHeight = GetCVar("raidFramesHeight")
	self.origWidth = GetCVar("raidFramesWidth")
	SetCVar("raidFramesHeight", 72)
	SetCVar("raidFramesWidth", 72)
	self:RegisterEvent("PLAYER_LOGOUT")

	InterfaceOptionsRaidFramePanelRaidFrameHeightSlider:Hide()
	InterfaceOptionsRaidFramePanelRaidFrameWidthSlider:Hide()
	CompactRaidFrameContainer:SetScale(0.5)
	-- CompactRaidFrameManagerContainerResizeFrame:SetScale(0.5)

	db = _G[SavedVars_Name] or { dbversion = DBVERSION }
	SBRF.db = db
end

function SBRF:OnEnable()
end

function SBRF:OnDisable()
end
